import { ElementRef, ChangeDetectorRef, OnDestroy, Renderer2 } from '@angular/core';
import { Confirmation, ConfirmationService, OverlayService, PrimeNGConfig } from 'primeng/api';
import { Subscription } from 'rxjs';
import { AnimationEvent } from '@angular/animations';
import * as i0 from "@angular/core";
import * as i1 from "@angular/common";
import * as i2 from "primeng/button";
export declare class ConfirmPopup implements OnDestroy {
    el: ElementRef;
    private confirmationService;
    renderer: Renderer2;
    private cd;
    config: PrimeNGConfig;
    overlayService: OverlayService;
    key: string;
    defaultFocus: string;
    showTransitionOptions: string;
    hideTransitionOptions: string;
    autoZIndex: boolean;
    baseZIndex: number;
    style: any;
    styleClass: string;
    container: HTMLDivElement;
    subscription: Subscription;
    confirmation: Confirmation;
    _visible: boolean;
    documentClickListener: any;
    documentResizeListener: any;
    scrollHandler: any;
    get visible(): any;
    set visible(value: any);
    constructor(el: ElementRef, confirmationService: ConfirmationService, renderer: Renderer2, cd: ChangeDetectorRef, config: PrimeNGConfig, overlayService: OverlayService);
    onAnimationStart(event: AnimationEvent): void;
    onAnimationEnd(event: AnimationEvent): void;
    getElementToFocus(): any;
    align(): void;
    hide(): void;
    accept(): void;
    reject(): void;
    onOverlayClick(event: any): void;
    bindListeners(): void;
    unbindListeners(): void;
    bindDocumentClickListener(): void;
    unbindDocumentClickListener(): void;
    onWindowResize(): void;
    bindDocumentResizeListener(): void;
    unbindDocumentResizeListener(): void;
    bindScrollListener(): void;
    unbindScrollListener(): void;
    unsubscribeConfirmationSubscriptions(): void;
    onContainerDestroy(): void;
    restoreAppend(): void;
    get acceptButtonLabel(): string;
    get rejectButtonLabel(): string;
    ngOnDestroy(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<ConfirmPopup, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<ConfirmPopup, "p-confirmPopup", never, { "key": "key"; "defaultFocus": "defaultFocus"; "showTransitionOptions": "showTransitionOptions"; "hideTransitionOptions": "hideTransitionOptions"; "autoZIndex": "autoZIndex"; "baseZIndex": "baseZIndex"; "style": "style"; "styleClass": "styleClass"; "visible": "visible"; }, {}, never, never>;
}
export declare class ConfirmPopupModule {
    static ɵfac: i0.ɵɵFactoryDeclaration<ConfirmPopupModule, never>;
    static ɵmod: i0.ɵɵNgModuleDeclaration<ConfirmPopupModule, [typeof ConfirmPopup], [typeof i1.CommonModule, typeof i2.ButtonModule], [typeof ConfirmPopup]>;
    static ɵinj: i0.ɵɵInjectorDeclaration<ConfirmPopupModule>;
}
